unit MapSave;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, UOMapComp;

type
  TfrmMapSave = class(TForm)
    rgType: TRadioGroup;
    btnOK: TButton;
    Button2: TButton;
    rgZoom: TRadioGroup;
    cbStatics: TCheckBox;
    cbBlackWater: TCheckBox;
    lbArea: TListBox;
    lblArea: TLabel;
    cbPatch: TCheckBox;
    procedure btnOKClick(Sender: TObject);
    procedure rgTypeClick(Sender: TObject);
  private
    { Private declarations }
    FUOMap : TUOMap;
  public
    { Public declarations }
    procedure Execute(AUOMap : TUOMap);
  end;

var
  frmMapSave: TfrmMapSave;

implementation

uses Main, InsideUOText;

{$R *.DFM}

procedure TfrmMapSave.Execute;
var
  I : Integer;
begin
  FUOMap := AUOMap;

  if FUOMap.FViews.Count <= 0 then
    raise Exception.Create(ErrorNoViewsForMapType);

  lbArea.Clear;
  for I := 0 to FUOMap.FViews.Count-1 do
    lbArea.Items.Add(FUOMap.FViews[I]);
  lbArea.ItemIndex := 0;

  ShowModal;
end;

procedure TfrmMapSave.btnOKClick(Sender: TObject);
var
  FileName : String;
  SAlt : TMapAlt;
  SZoom : TMapZoom;
  SFlags : TMapFlags;
  Size : TRect;
  SArea : TMapViewArea;
begin
  SZoom := zm1x1;
  case rgZoom.ItemIndex of
    0 : SZoom := zm1x1;
    1 : SZoom := zm1x8;
  end;

  SArea := TMapViewArea(FUOMap.FViews.Objects[lbArea.ItemIndex]);
  Size := SArea.GetBoundingRect(SZoom);
  frmMain.SavePicture.FileName := lbArea.Items[lbARea.ItemIndex] + '.bmp';

  if not frmMain.SavePicture.Execute then Exit;
  FileName := frmMain.SavePicture.FileName;

  SAlt := TMapAlt(rgType.ItemIndex);
  SFlags := [];
  if cbStatics.Checked then SFlags := SFlags + [flStatics];
  if cbPatch.Checked then SFlags := SFlags + [flPatch];
  if cbBlackWater.Checked then SFlags := SFlags + [flNulWater];

  Screen.Cursor := crHourglass;
  try
    FUOMap.Save(FileName, Size, SFlags, SAlt, SArea, SZoom);
  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TfrmMapSave.rgTypeClick(Sender: TObject);
begin
  case rgType.ItemIndex of
    0 : rgZoom.Enabled := True;
    1 :
      begin
        rgZoom.Enabled := False;
        rgZoom.ItemIndex := 0;
      end;
  end;

end;

end.
